:- ensure_loaded( '../src/init_lib' ).
:- ensure_loaded( library(sys_info) ).		% /1.

create_bcktrcks( [] ).
create_bcktrcks( [H|T] ) :-
	( atom_concat(Hstem,'.gz',H) ->
		atom_concat( 'gunzip ', H, Gunzip ),
		sys_info( Gunzip )
		;
		Hstem = H
	),
	% listing( exec_extension
	exec_extension( bctrcks, Hstem ),
	atom_concat( 'gzip ', Hstem, Gzip ),
	sys_info( Gzip ),
	create_bcktrcks( T ).

exec_extension( bctrcks, BareFile ) :-
	open( BareFile, read, In ),
	read( In, c(_) ),
	read( In, FirstCx ),
	( FirstCx = x(c,_CLL,_Mis) -> 
		read( In, b(_) ),
		read( In, x(b,_BLL,_Pnt) ),
		read( In, c(_) ), 
		read( In, FGCx )
		;
		FGCx = FirstCx
	),
	read( In, B ),
	% read( In, FGBx ),
	atom_concat( BareFile, '.bkt_available', AvailFile ),
	open( AvailFile, write, Avail ),
	atom_concat( BareFile, '.bkt_chosen', ChoFile ),
	open( ChoFile, write, Cho ),
	atom_concat( BareFile, '.bkt_distance', DistFile ),
	open( DistFile, write, Dist ),
	record_bctrcks( B, FGCx, In, Avail, Cho, Dist ),
	close( In ),
	close( Avail ),
	close( Cho ),
	close( Dist ).

record_bctrcks( end_of_file, _, _In, _Avail, _Cho, _Dist ) :- !.
record_bctrcks( _, x(c,_,_,PntPrs), In, Avail, Cho, Dist ) :-
	read( In, x(b,_,Pnt) ),
	length( PntPrs, AvailPnts ),
	write( Avail, AvailPnts ), nl( Avail ),
	once( nth( Nth, PntPrs, Pnt-_ ) ),
	write( Cho, Nth ), nl( Cho ),
	Jump is Nth / AvailPnts,
	write( Dist, Jump ), nl( Dist ),
	read( In, _C ),
	read( In, NxCx ),
	read( In, NxB ),
	record_bctrcks( NxB, NxCx, In, Avail, Cho, Dist ).
