
:- ['../../src/init_lib'].

:- requires( list_frequency/2 ).
/* 
     convert a csv file to a data/2 prolog data file.
     The terms/facts read: data( InstList, Tms ).
     Where InstList is the instantiaon list of all variables in the dataset,
     and Tms is the number of times the instantiation appearred.

     */

csv_to_mpl( FileIn, FileOut ) :-
     csv_read_file( FileIn, Csv, [] ),
     list_frequency( Csv, Freq ),
     tell( FileOut ),
     findall( D, 
               ( member(Row-Tms,Freq),
                 Row =.. [row|Inst],
                 D =.. [data,Inst,Tms],
                 portray_clause( D )
                 ),
                         _Data ),
     told.
