:- ensure_loaded( '../run' ).
:- ensure_loaded( 'src/llhood/lhood_canonical_uai01' ).
% :- ensure_loaded( '../src/display_model' ).
% :- ensure_loaded( '../../auxil/create_graphs' ).
% :- ensure_loaded( '../../auxil/create_visits' ).
% :- ensure_loaded( 'auxil/create_counts' ).
% :- ensslb_asia_1k_2004_orgure_loaded( 'auxil/create_blankets' ).

data_format(data(_,_,_)).

possible_values( _, [0,1] ).

% :- bb_put( sr, off ).

run_scm :-
	Runs = [
          model_type( bn ),
		runs_file(scm_simple),
		print( [24,28,29] ), % defaults currently
		progress('.',5),
		results_dir(out_scm)
		],
	run( Runs ).

scm_gen_each_vid( List, Id ) :-
	length( List, Length ),
	count( 1, Length, Id ).

scm_gen_vstructure( AccMOD, H, Vstr, ExV, RepV ) :-
	scm_gen_vstructure_1( H, AccMOD, Vstr, ExV, RepV ).

scm_gen_vstructure_1( 1, [H|T], [RepV|T], H, RepV ) :-
	!.
scm_gen_vstructure_1( I, [H|T], Vstr, ExV, RepV ) :-
	I > 1,
	NxI is I - 1,
	Vstr = [H|TVstr],
	scm_gen_vstructure_1( NxI, T, TVstr, ExV, RepV ).

count( Lim, Lim, Lim ) :- !.
count( This, _Lim, This ).
count( This, Lim, Count ) :-
	Next is This + 1,
	count( Next, Lim, Count ).
