:- ensure_loaded( '../src/display_model' ).		% mold_list/3,
									% leaf_ids_classified/4.

% assumes loaded data
% cart_misclassifications( Cart, MissCl ) :-
cart_misclassifications(  Cart, MissCl ) :-
	bb_get( all_categories, Kats ),
	mold_list( Kats, 0, Zs ),
	cart_misclassifications_1( Cart, Kats, Zs, MissCl ).

cart_misclassifications_1(  cart(_F,_S,L,R), Ks, Zs, MissCl ) :-
	!,
	cart_misclassifications_1( L, Ks, Zs, Lmc ),
	cart_misclassifications_1( R, Ks, Zs, Rmc ),
	MissCl is Lmc + Rmc.
cart_misclassifications_1( leaf(_D,IDs), Ks, Zs, MissCl ) :-
	findall( H-HClass, 
			( member(H,IDs ),
			  has_category(H,HClass) ),
	  	IdClPs ),
	leaf_ids_classified( IdClPs, Ks, Zs, Classified ),
	max_list_w_rem_sum( Classified, _Max, MissCl ).
	
max_list_w_rem_sum( [H|T], Max, Sum ) :-
	max_list_w_rem_sum( T, H, Max, 0, Sum ).

max_list_w_rem_sum( [], Max, Max, Sum, Sum ).
max_list_w_rem_sum( [H|T], CurMax, Max, AccSum, Sum ) :-
	( H > CurMax -> 
		NxSum is AccSum + CurMax,
		NxMax = H 
		;
		NxSum is AccSum + H,
		NxMax = CurMax
	),
	max_list_w_rem_sum( T, NxMax, Max, NxSum, Sum ).
