:- ensure_loaded( library(requires) ).		%.
:- requires( kvs_incr_v_by/4 ).

count_classes( [] ).
count_classes( [H|T] ) :-
	open( H, read, In ),
	read( In, Fst ),
	count_classes_on_stream( Fst, In, [], Classes ),
	close( In ),
	write( H-Classes ), nl,
	count_classes( T ).

count_classes_on_stream( end_of_file, _In, Classes, Classes ).
count_classes_on_stream( Term, In, Acc, Classes ) :-
	functor( Term, data, LastPos ),
	arg( LastPos, Term, Class ),
	kvs_incr_v_by( Acc, Class, 1, NxAcc ),
	read( In, NxTerm ),
	count_classes_on_stream( NxTerm, In, NxAcc, Classes ).
