/* 
     An attempt to merge gvz_nth_fterm and gvz_nth_gz.pl (the latter
     being out of date).
     */

:- ensure_loaded( '../../src/init_lib' ).

:- ensure_loaded( library(lists) ).
                              % nth/3, append/3, memberchk/3.
:- ensure_loaded( library(charsio) ).		          %.
:- ensure_loaded( library(apply_macros) ).		     % maplist/3.

:- elm( 'auxil/data_calls_from_stats_file' ).   % /2.
:- elm( 'src/model_type_calls' ).

:- requires( opts_select_infiles/3 ).
:- requires( to_number/1 ).
% :- requires( read_terms/2 ).
:- requires( werr/2 ).
:- requires( opts_have_help/2 ).
:- requires( write_help/3 ).
:- requires( has_extension/3 ).
:- requires( select_either_all/4 ).
:- requires( gunzip_easy/2).
:- requires( gzip_easy/1).
:- requires( read_nth_unifying_term/4 ). 
:- requires( load_1_loads/2 ). 
               % read_nth_unifying_term_from_stream/5, actually.
:- requires( to_list/2 ). 

gvz_nth( InOpts ) :-
     to_list( InOpts, Opts ),
     opts_have_help( Opts, Screen ),
     !,
     gvz_nth_help( Screen, Opts ).

gvz_nth( LdOpts ) :-
     % listing( elm/1 ),
     load_1_loads( LdOpts, Opts ),
	opts_select_infiles( Opts, [File|_Fs], OthOpts ),
	% atom_concat( BareFile, '.fterms', File ),
     has_extension( File, BareFile, Ext ),
     nl, nl,
     data_calls_from_stats_file( BareFile, ModType ),
     modtype_loads( ModType, RedModType, Arg ),
	gvz_nth_defaults( File, Ext, Defs ),
	append( OthOpts, Defs, AllOpts ),
     select_either_all( from, OthOpts, Defs, PrvFroms ),
     maplist( to_number, PrvFroms, Froms ),
	% memberchk( from(PrvFrom), AllOpts ),
     % to_number( PrvFrom, From ),
	memberchk( for(PrvFor), AllOpts ),
	memberchk( match(Match), AllOpts ),
     to_number( PrvFor, For ),
	nl,
     werr( ['Using file: ',File], info ),
     werr( ['Using from: ',l(Froms)], info ),
     werr( ['Using  for: ',For], info ),
     nl, nl,
	Froms = [From|TFroms], 
     From > 0,
     ext_open( Ext, BareFile, In ),
     memberchk( fname(Fname), AllOpts ),
	gvz_display_options( AllOpts, Fname, DOpts ),
     compare( Op, 1, From ),
	gvz_nth_on_stream( Op, 1, From, Match, TFroms, For, In, RedModType, Arg, DOpts ),
	close( In ),
     ext_closed( Ext, File ).

gvz_display_options( AllOpts, File, DOpts ) :-
	( select(colour(Clr), AllOpts, RemOpts) ->
          AddOpts = [file(File)|RemOpts],
		( Clr = bnw -> 
			DOpts = [colour(Clr),node_style(solid)|AddOpts]
			;
			DOpts = [colour(Clr)|AddOpts]
		)
		;
		DOpts = [file(File)|AllOpts]
	).

gvz_nth_defaults( Defs ) :-
     gvz_nth_defaults( _File, _Ext, Defs ).
gvz_nth_defaults( File, Ext, Defs ) :-
     ( var(Ext) ->
          Match = '_Any'
          ;
          ( Ext == fterms -> 
               Match = st/4
               ;
               Match = c/1
          )
     ),
     ( var(File) -> File = '<File>'; true ),
	Defs = [ from(1), for(1), exec(gv),match(Match),fname(File)].
     % change gv to xv for pngs....

gvz_nth_on_stream( =, I, _From, Match, Froms, For, In, Type, Arg, Opts ) :-
	!,
	gvz_next_n( For, I, Match, In, Type, Arg, Opts, Cont ),
     gvz_next_nth_on_stream( Froms, Cont, Match, For, In, Type, Arg, Opts ).

gvz_nth_on_stream( <, N, From, Match, Froms, For, In, Type, Arg, DOpts ) :-
	read( In, InTerm ),
     functor( InTerm, Name, Arity ),
     ( Match == Name/Arity ->
	     NxN is N + 1
          ;
          NxN is N
     ),
     compare( Op, NxN, From ),
	gvz_nth_on_stream( Op, NxN, From, Match, Froms, For, In, Type, Arg, DOpts ).

gvz_next_nth_on_stream( [], _Cont, _Match, _For, _In, _Type, _Arg, _Opts ).
gvz_next_nth_on_stream( [H|T], Cont, Match, For, In, Type, Arg, Opts ) :-
     compare( Op, Cont, H ),
     gvz_nth_on_stream( Op, Cont, H, Match, T, For, In, Type, Arg, Opts ).

gvz_next_n( For, I, Match, In, Type, Arg, DOpts, Cont ) :-
	For > 0,
	!,
     % read_first_matching( In, Match, Cart ),
     Str = gvz/1,
     Match = Name/Arity,
     functor( MTerm, Name, Arity ),
     read_nth_unifying_term_from_stream( In, 1, MTerm, Str, Cart ),
	% read( In, st(Tms,LL,PrvMis,RedM) ),
	gvz_model( Type, Cart, I, Arg, DOpts ),
	NxFor is For - 1,
     NxI is I + 1,
	gvz_next_n( NxFor, NxI, Match, In, Type, Arg, Cont ).
gvz_next_n( _, Cont, _Match, _In, _Type, _Arg, Cont ).

gvz_model( cart_red, FStr, I, Ids, Opts ) :-
	!,
     file_structure_to_model_and_title( FStr, PrvCart, LowTit ),
     memberchk( file(File), Opts ),
     % HERE still need title on/off OPT
     write_to_chars( I:File, IFileCs ),
     atom_codes( IFile, IFileCs ),
     % append( IFileCs, LowTitCs, TitCs ),
     Tit = [IFile,LowTit],
	( red_cart_to_full( PrvCart, 0, Ids, Cart) -> true; PrvCart=Cart),
     memberchk( exec(Exec), Opts ),
	display_model( Cart, [title(Tit),exec(Exec)|Opts] ).
     % change the gv to eog or xv for pngs.... add this to help HERE

file_structure_to_model_and_title( st(Tms,LL,PrvMis,Cart), Cart, Tit ) :-
     ( atomic(PrvMis) -> 
          Mis = PrvMis, 
          Tit = Tit1
          ;
          PrvMis = [Mis|TMis],
          write_list_to_atoms_list( TMis, Tits ),
          Tit = [Tit1|Tits]
     ),
	write_to_chars( vst(Tms):lhd(LL):mclsf(Mis), Codes ),
     atom_codes( Tit, Codes ).
file_structure_to_model_and_title( c(Cart), Cart, '' ).

ext_open( gz, Stem, In ) :-
     werr( [gunzipping(Stem)], info ),
     gunzip_easy( _, Stem ),
	open( Stem, read, In ).
ext_open( fterms, Stem, In ) :-
     has_extension( File, Stem, fterms ),
	open( File, read, In ).
ext_open( '', Stem, In ) :-
	open( Stem, read, In ).

ext_closed( gz, File ) :-
     werr( [gzipping,File], info ),
     gzip_easy( File ).
ext_closed( '', _File ).
ext_closed( fterms, _File ).

write_list_to_atoms_list( [], [] ).
write_list_to_atoms_list( [H|T], [Htit|TTits] ) :-
     write_to_chars( H, HtitCs ),
     atom_codes( Htit, HtitCs ),
     write_list_to_atoms_list( T, TTits ).

modtype_loads( cart, cart, null ) :-
	elm( 'carts/src/lhood' ),
     elm( 'carts/src/display_model' ),
	elm( 'carts/auxil/cart_misclassifications' ).
modtype_loads( cart_red(_), cart_red, Ids ) :-
	elm( 'carts/auxil/red_cart_to_full' ),
	once( modtype_loads(cart,_,_) ),
	bb_get( idsd_put, t(_NofF,_DataSet,_Splits,Ids) ).
modtype_loads( ped, ped, null ) :-
	elm( 'pedigree/src/ped_likelihood' ).

gvz_nth_help( Width, InOpts ) :-
     gvz_nth_defaults( Defs ),
     Descr  = 'visualise a number of cart trees',
     Opts = [
               opt(exec,gv,'executable to invoke for displaying '),
               opt(fname,'filename to use at title'),
               opt(for,'continue visualising for '),
               opt(m(from),'start visualisation at ' ),
               opt(match,spec,'only count terms that match this spec')
               % Use the following for multi + required opts
               % opt(m(r(ext)),'file extensions to use, multi,'),
     ],
     Name = gvz_nth,
     Exs = [
               u(Name,'*fterms'),
               u(Name,'*fterms node_style=empty exec=eog  % generates empty node pngs'),
               u(Name,'*gz notitle=true'),
               u(Name,'from=10 from=100 from=1000 from=10000 from=100000 from=500000 from=900000 tr_uc_rm_idsd_fprs_a0_95b1_i1M__s209'),
               u(Name,'tr_uc_rm_idsd_fprs_a0_95b1_i1M__s90 from=1 from=100 fname=temper_3ch_s90'),
               u(Name,'upsh f gvz_nth load=~/bch/pyruvate/ky_1571_ft_names.pl from=1000 tr_uc_rm_idsd_fprs_a0_95b1_i1M__s327 node_style=empty colour=bnw notitle=true')
          ],
     HelpOpts = [width(Width)|InOpts],
     Note = ['See also elm(carts/auxil/point_estimates).',
             'All options are passed to (carts) display_model/2'
     ],
     ToDo = 'Point estimates uses the old version. UPDATE it.',
     write_help( help(f1('gvz_nth'),Descr,Opts,Note,Exs,ToDo), Defs, HelpOpts ).
