:- module( cart_model_sanity, [cart_model_sanity/3] ).
:- ensure_loaded( library(ordsets) ).		%.

% compile( cart_model_sanity ), save_modules( [cart_model_sanity], cart_model_sanity ), halt.

cart_model_sanity( Cart, Fts, ExpNoOfIds ) :-
	cart_model_san_acc_ids( Cart, [], 0, Fts, Ids ),
	length( Ids, Length ),
	( Length =:= ExpNoOfIds ->
		write( model_was_sane ), nl
		;
		Diff is ExpNoOfIds - Length,
		write( insanity-diff_from_exp_no_of_ids(Diff) ), nl
	).

cart_model_san_acc_ids( cart(F,_Val,L,R), Acc, D, Fts, Ids ) :-
	!,
	( (nonvar(F),F>=1,F=<Fts) -> 
		true
		;
		write( insanity-cart_feature_not_within_limits(F,Fts) ), nl
	),
	D1 is D + 1,
	cart_model_san_acc_ids( L, Acc, D1, Fts, LAcc ),
	cart_model_san_acc_ids( R, LAcc, D1, Fts, Ids ).
cart_model_san_acc_ids( leaf(D,LfIds), Acc, CalcD, _Fts, Ids ) :-
	ord_union( Acc, LfIds, Ids, New ),
	( New == LfIds -> 
		true
		;
		ord_intersection( LfIds, Acc, Common ), 
		write( insanity-duplicated_ids(Common) ), nl
	),
	( D =:= CalcD -> 
		true
		; 
		write( insanity-diff_in_depths(D,CalcD) ), nl
	).
cart_model_san_acc_ids( Str, _Acc, _Fts, _Ids ) :-
	write( insanity-unknow_cart_str(Str) ), nl.
