:- ensure_loaded( the_true_bn_str_of ).
% :- ensure_loaded( '../../bns/auxil/disp_bn' ).
:- ensure_loaded( library(ugraphs) ).

:- ensure_loaded( '../../src/init_lib' ).

:- ensure_loaded( '../loss' ). 			% bn_eg/2.
:- ensure_loaded( '../../bns/src/llhood/lhood_canonical_bdeu_sharp_multi_spl.pl' ).
% :- ensure_loaded( '../../bns/src/llhood/lhood_canonical_bdeu_multi_spl.pl' ).
% :- ensure_loaded( '../../bns/src/llhood/logamma_yap.pl' ).

true_llhood( [True,Which,Base] ) :-

	atom_concat( '../true/', True, BackTrue ),
	atom_concat( BackTrue, '.slp', TrueSlp ),
	the_true_bn_str_of( TrueSlp, Nds, BnEdges ),
	% write( bn_edges(BnEdges) ), nl,
	% bn_eg( BnEdges, EgEdges ),
	% write( eg_edges(EgEdges) ), nl,
	add_edges( [], BnEdges, BnEdged ),
	add_vertices( BnEdged, Nds, BnComp ),
	transpose( BnComp, Bn ),
	write( True-Bn ), nl,
	( Which =:= 500 -> Wh = '_500.pl'; 
		( Which =:= 1000 -> Wh = '_1K.pl';
			write( wrong_which(Which) ), nl, abort ) ),
	% Base = '/local/usr/nicos/tara/jmlr/prior01/',
	atom_concat( Base, 'data/', Data ),
	atom_concat( Data, True, DataTrue ),
	atom_concat( DataTrue, Wh, DataWh ),
	ensure_loaded( DataWh ),

	atom_concat( Base, 'true/', BaseT ),
	atom_concat( BaseT, True, BaseTTrue ),
	atom_concat( BaseTTrue, '_vrs', BaseTVrs ),
	ensure_loaded( BaseTVrs ),

	model_llhood( Bn, Contributions ),
	sum_model_llhood_family_contributions( Contributions, 0, CLh ),
	write( (True,Which): CLh ), nl.

sum_model_llhood_family_contributions( [], Sum, Sum ).
sum_model_llhood_family_contributions( [_-_+Cnt|T], Acc, Sum ) :-
	NxAcc is Acc + Cnt,
	sum_model_llhood_family_contributions( T, NxAcc, Sum ).
