:- ensure_loaded( '../../src/lib/file_to_list_of_lines' ).
:- ensure_loaded( '../../src/lib/kv_additive_consolidation' ).

parity_to_data( [File] ) :-
	file_to_list_of_lines( File, Ls ),
	atom_concat( File, '.pl', DataF ),
	parity_lines_to_data_inst( Ls, 1, Insts ),
	% kv_additive_consolidation( Insts, Consol ),
	open( DataF, write, Out ),
	write_unconsolidated_data( Insts, Out ),
	% write_consolidated_data( Consol, Out ),
	close( Out ).

parity_lines_to_data_inst( [], _, [] ).
parity_lines_to_data_inst( [H|T], N, [HInst-1|TInst] ) :-
	parity_line_to_data_inst( H, HInst ),
	% write( ln(N) ), nl,
	NxN is N + 1,
	parity_lines_to_data_inst( T, NxN, TInst ).

parity_line_to_data_inst( [Wh,9|T], Inst ) :- % Parity1
% parity_line_to_data_inst( [Wh,9,9|T], Inst ) :- % Parity1
	!,
	number_codes( VarInst, [Wh] ),
	% write( wh(VarInst) ),
	Inst = [VarInst|TInst],
	parity_line_to_data_inst( T, TInst ).
parity_line_to_data_inst( [], [] ).
% parity_line_to_data_inst( [Wh], [VarInst] ) :- % Parity1
	% number_codes( VarInst, [Wh] ).
	% number_codes( VarInst, [Wh] ).

write_consolidated_data( [], _Out ).
write_consolidated_data( [K-Tms|T], Out ) :-
	Data =.. [data,K,Tms],
	writeq( Out, Data ), write( Out, '.' ), nl( Out ),
	write_consolidated_data( T, Out ).
	
write_unconsolidated_data( [], _Out ).
write_unconsolidated_data( [K-1|T], Out ) :-
	Data =.. [data,K],
	writeq( Out, Data ), write( Out, '.' ), nl( Out ),
	write_unconsolidated_data( T, Out ).
