% :- module( edit_mod, [variable_has_position_in_cart/3,edcart_to_concrete_cart/2,
				% feature_choice_splits_ids/3,navigate/7] ).

/*
compile( edit_mod ), save_modules( [edit_mod], edit_mod ), halt.
*/

feature_choice_splits_ids( F, Ch, AllLeftIds ) :-
	Idx is F * 11 + Ch,
	once( user:feature_choice_t( Idx, AllLeftIds ) ).

% Position could be stored in LeavesList
variable_has_position_in_cart( Cart, Var, Position ) :-
	var( Cart ),
	!,
	Cart == Var,
	Position = []. % else, fail = is not here 
variable_has_position_in_cart( cart(_,_,_,_,L,_R), Var, Position ) :-
	variable_has_position_in_cart( L, Var, TPosition ),
	!,
	Position = [l|TPosition].
variable_has_position_in_cart( cart(_,_,_,_,_L,R), Var, Position ) :-
	variable_has_position_in_cart( R, Var, TPosition ),
	Position = [r|TPosition].

edcart_to_concrete_cart( ec(Cart,Lvs,_Psts), CartOut ) :-
	instantiate_leaves( Lvs ),
	six_arg_cart_to_four_arg( Cart, CartOut ).

instantiate_leaves( [] ).
instantiate_leaves( [H-H|T] ) :-
	instantiate_leaves( T ).

six_arg_cart_to_four_arg( cart(Ft,Ch,_Ids,_Poss,L,R), Out ) :-
	!,
	Out = cart(Ft,Ch,FrL,FrR),
	six_arg_cart_to_four_arg( L, FrL ),
	six_arg_cart_to_four_arg( R, FrR ).
six_arg_cart_to_four_arg( leaf(D,I,P), leaf(D,I,P) ) :-
	!. % sanity checking
six_arg_cart_to_four_arg( Oth, _ ) :-
	write( dont_know_about_this_other_one(Oth) ), nl, abort.

navigate( [], Cart, CurD, PruneNode, D, PrunedCart, ConnctVar ) :-
	D = CurD,
	PruneNode = Cart,
	PrunedCart = ConnctVar.
navigate( [l|T], Cart, CurD, PruneNode, D, PrunedCart, ConnctVar ) :-
	!,
	Cart = cart(F,Ch,Ids,Poss,L,R),
	NxD is CurD + 1,
	navigate( T, L, NxD, PruneNode, D, PrndL, ConnctVar ),
	PrunedCart = cart(F,Ch,Ids,Poss,PrndL,R).
navigate( [r|T], Cart, CurD, PruneNode, D, PrunedCart, ConnctVar ) :-
%%% navigate( [l|T], Cart, CurD, PruneNode, D, PrunedCart, ConnctVar ) :-
	Cart = cart(F,Ch,Ids,Poss,L,R), 
	NxD is CurD + 1,
	navigate( T, R, NxD, PruneNode, D, PrndR, ConnctVar ),
	PrunedCart = cart(F,Ch,Ids,Poss,L,PrndR).
