:- ensure_loaded( '../../../src/sload' ).				% /1.
:- ensure_loaded( '../../../src/construct_scall' ).		% s/1.

:- ensure_loaded( '../data/idsd' ).					% /4.

% When limiting depth to =< n at split_leaf we have m number of possible carts
% n     m
% 1     66 
% 2     57861
% 
posterior :-
	idsd( 3, kyph_train_080, Splits, Ids ),
	sload( ['../slps/ids_split.slp',rm(false)] ),
	Args = [Splits,Ids,0.95/1,Cart],
	spec_constructs_scall( cart/4, ns, Path, Args, Call ),
	findall( Path-Cart,
				slp:Call,
				Paths ),
	length( Paths, Lgt ), 
	write( nof(Lgt) ), nl,
	abort.

record_path( Path ) :-
	open( 'paths.pl', append, Out ),
	write( Out, Path ), write( Out, '.' ), nl( Out ),
	close( Out ).

depth_of_cart( cart(_,_,L,R), Dpth ) :-
	depth_of_cart( L, LDpth ),
	depth_of_cart( R, RDpth ),
	Dpth is max( LDpth, RDpth ) + 1.
depth_of_cart( leaf(_,_), 0 ).
