/*
this is a run in the spirit of Fig. 5.
Be warned to change Dir to some filesystem with loads of free space.
To reproduce the density figure:
(a)   run the experiment by, starting a prolog (SICStus or Yap) and
      compile( run_pima_fig5 ).
      run_pima_fig5.
      halt.
(b)   cd into out_pima_fig8 in the directory you have chosen and 
      gunzip *.gz
(c)   start a prolog and
      ['<mcmcms_dir>/carts/auxil/lld_stats_for_stem'].
      lld_stats_for_stem( [tr_uc_rm_pima_idsd_a0_95b0_8_i50K__s419,tr_uc_rm_pima_idsd_a0_95b1_i50K__s473] ).
      halt.
(d)   gzip tr_uc_rm_pima_idsd_a0_95b0_8_i50K__s419 tr_uc_rm_pima_idsd_a0_95b1_i50K__s473
(e)   create the predictions on the pima_test by starting a prolog and
      compile( '<mcmcms_dir>/carts/auxil/test_classification' ).
      test_classification( [train(pima_train),test(pima_test),cohese(best),'tr_uc_rm_idsd_pima_train_a0_95b0_8_i50K__s419.mvisits','tr_uc_rm_idsd_pima_train_a0_95b0_8_i50K__s473.mvisits'] ).
      halt.

(f)  compute the differences file with starting a prolog and
     compile( '<mcmcms_dir>/auxil/predicted_diff_bins' ).
     predicted_diff_bins( [out='predicted_best_pbc_419_vs_473.diffs','tr_uc_rm_idsd_pima_train_a0_95b0_8_i50K__s419.predicted_best_pbc','tr_uc_rm_idsd_pima_train_a0_95b0_8_i50K__s473.predicted_best_pbc'] ).
     [halt].

Visualise frequency data in file predicted_best_pbc_419_vs_473.diffs with gnuplot or R.

for upsh (e) and (f) above become: 
upsh ~/islp/mcmcms/carts/auxil/test_classification train=pima_train test=pima_test mvisits=1.mvisits l=n cohese=best
upsh ~/islp/mcmcms/auxil/predicted_diff_bins file=tr_uc_rm_idsd_pima_train_a0_95b0_8_i50K__s419.predicted_best_pbc file=tr_uc_rm_idsd_pima_train_a0_95b0_8_i50K__s473.predicted_best_pbc out=predicted_best_pbc_419_vs_473.diffs
*/

:- ensure_loaded( '../../run' ).
:- elm( 'carts/src/lhood' ). 		% llhood_w_diff/5, model_llhood/2.
:- elm( 'auxil/create_mvisits' ).  % exec_extension/2.

run_pima_fig5 :-
	Dir = '/local/d1p1/nicos/kong/ijcai05/pima/out_pima_fig5',
	% Dir = '/local/d0p6/nicos/ijcai05/pima/out_pima_fig5',
	% Dir = out_pima_fig5,
	Runs = [	runs_file( runs_pima_fig5 ),
			results_dir( Dir ),
			print([24,28,29,31])
		],
	run( Runs ).
