:- ensure_loaded( '../../../src/init_lib' ).
:- ensure_loaded( library(lists) ).		% member/2.
:- ensure_loaded( library(system) ).		% make_directory/1, 
                                             % working_directory/2.
:- ensure_loaded( library(flatten) ). 		% /2.
:- ensure_loaded( library(sys_info) ). 		% /1.

autoe :-
	Dir = 'ut_exp',
	make_directory( Dir ),
	working_directory( _Old, Dir ),
	A = ["a","i","p","g"],
	Params = [p(1,1,1)/A,p(0.8,1,1)/A,p(0.6,1,1)/A,
	                     p(1,0.8,1)/A,p(1,0.6,1)/A,
					 p(1,1,0.8)/A,p(1,1,0.6)/A,
					 p(1.2,1,1)/A,p(1,1.2,1)/A,p(1,1,1.2)/A],
	member( p(Mi,Mp,Mg)/CNs, Params ),
	member( CnameCs, CNs ),
	open( '../m_parameters.pl', write, MPs ),
	write_canonical( MPs, m_parameters(Mi,Mp,Mg) ),
	write( MPs, '.' ), nl( MPs ),
	close( MPs ),
	out_filename( Mi, Mp, Mg, CnameCs, Fout ),
	flatten( ["upsh n_samples_tex call=",CnameCs,"=V:V col=1 out=",Fout," gv=false samples=10000 slp=../weighed_eff.slp sort=true"], UpshCs ),
	atom_codes( Upsh, UpshCs ),
	sys_info( Upsh ),
	fail.

autoe :-
	working_directory( _, '..' ).

out_filename( Mi, Mp, Mg, CnamCs, OutFname ) :-
	number_codes( Mi, MiCs ),
	number_codes( Mp, MpCs ),
	number_codes( Mg, MgCs ),
	flatten( ["ns_",CnamCs,"_i",MiCs,"_p",MpCs,"_g",MgCs], OutFname ).
