
:- ensure_loaded( library(lists) ).       % append/3.
:- requires( break_list_on/4 ).

% Assumes dot, '.', separates extension from step. Dot is not returned in Ext.

has_extension( File ) :-
	has_extension( File, Stem, _ ),
	File \== Stem.

has_extension( File, Ext ) :-
     has_extension( File, _, Ext ).

has_extension( File, Stem, Ext ) :-
     var( File ), 
     atom( Stem ),
     atom( Ext ),
     !,
     atom_codes( Stem, StemCs ),
     ( Ext = '' -> 
          atom_codes( File, StemCs )
          ;
          atom_codes( Ext, ExtCs ),
          append( StemCs, [0'.|ExtCs], FileCs ),
          atom_codes( File, FileCs )
     ).

has_extension( File, Stem, Ext ) :-
	atom_codes( File, FileCs ), 
     reverse( FileCs, RevFileCs ),
     ( var(Ext) -> true;
          atom_codes(Ext,ExtCs),
          reverse(ExtCs,RevExtCs)
     ),
     break_list_on( RevFileCs, 0'., RevExtCs, RevStemCs ),
     !,
     (var(Ext) -> 
          reverse( RevExtCs, ExtCs ),
          atom_codes( Ext, ExtCs )
          ;
          true
     ),
     reverse( RevStemCs, StemCs ),
     atom_codes( Stem, StemCs ).
has_extension( File, File, '' ).
