:- requires( digit/3 ).
:- requires( decimal_separator/3 ).

parse_number(N) -->
	   init_number_code( D ),
        parse_number_rest(Ds),
        {
            number_codes(N,[D|Ds])
        }.

parse_number_rest([D|Ds]) -->
	   number_code( D ),
	   !,
        parse_number_rest(Ds).
parse_number_rest([]) --> "".

init_number_code( D ) --> 
	"-", !, {D = 0'-}.
init_number_code( D ) --> 
	number_code( D ).

number_code( D ) --> 
	digit( D ), !.
number_code( D ) -->
	decimal_separator( D ).
